using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Data.OleDb;

public partial class _Default : System.Web.UI.Page
{

    public void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            DataTable employeesTable = GetDataTable("SELECT EmployeeID, FirstName, LastName, Address FROM Employees");
            employeesTable.PrimaryKey = new DataColumn[] { employeesTable.Columns["EmployeeID"] };

            Session["employeesTable"] = employeesTable;
        }
    }

    private static DataTable GetDataTable(string query)
    {
        OleDbConnection connection1 = new OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0; Data Source=" + System.Web.HttpContext.Current.Server.MapPath("~/App_Data/NWind.mdb"));
        OleDbDataAdapter adapter1 = new OleDbDataAdapter();
        adapter1.SelectCommand = new OleDbCommand(query, connection1);
        DataTable table1 = new DataTable();
        connection1.Open();
        try
        {
            adapter1.Fill(table1);
        }
        finally
        {
            connection1.Close();
        }
        return table1;
    }
    protected void RadGrid1_NeedDataSource(object source, GridNeedDataSourceEventArgs e)
    {
        if(Session["updateFlag"] != null && Session["initEdit"] != null)
        {
            DataTable employeesTable = (DataTable)Session["employeesTable"];

            for (int i = 0; i < RadGrid1.EditIndexes.Count; i++)
            {
                    GridDataItem dataItem = RadGrid1.MasterTableView.Items[RadGrid1.EditIndexes[i]] as GridDataItem;
                    GridEditableItem editItem = (dataItem.OwnerTableView.EditMode == GridEditMode.InPlace) ? (GridEditableItem)dataItem : (GridEditableItem)dataItem.EditFormItem;
                    GridEditManager mng = editItem.EditManager;

                    foreach (GridColumn column in dataItem.OwnerTableView.Columns)
                    {
                        if (column is IGridEditableColumn)
                        {
                            IGridEditableColumn editedColumn = column as IGridEditableColumn;
                            IGridColumnEditor editor = mng.GetColumnEditor(editedColumn);

                            string editorType = editor.ToString();
                            string editorText = null;

                            if (editor is GridTextColumnEditor)
                            {
                                editorText = (editor as GridTextColumnEditor).Text;
                            }
                            try
                            {
                                DataRow[] changedRows = employeesTable.Select("EmployeeID = " + editItem.OwnerTableView.DataKeyValues[editItem.ItemIndex]["EmployeeID"]);
                                changedRows[0][column.UniqueName] = editorText;
                            }
                            catch (Exception ex)
                            {
                                RadGrid1.Controls.Add(new LiteralControl("Unable to update Employee. Reason: " + ex.Message));
                            }
                        }
                    }
            }

            employeesTable.AcceptChanges();

            Session["employeesTable"] = employeesTable;

            Session["updateFlag"] = false;
            Session["editIndex"] = null;
        }
        else if (Session["insertFlag"] != null)
        {
            DataTable employeesTable = (DataTable)Session["employeesTable"];
            DataRow newRow = employeesTable.NewRow();

            GridEditableItem insertItem = RadGrid1.MasterTableView.GetInsertItem();
            GridEditManager mng = insertItem.EditManager;

                    foreach (GridColumn column in insertItem.OwnerTableView.Columns)
                    {
                        if (column is IGridEditableColumn)
                        {
                            IGridEditableColumn editedColumn = column as IGridEditableColumn;
                            IGridColumnEditor editor = mng.GetColumnEditor(editedColumn);

                            string editorType = editor.ToString();
                            string editorText = null;

                            if (editor is GridTextColumnEditor)
                            {
                                editorText = (editor as GridTextColumnEditor).Text;
                            }
                            try
                            {
                               newRow[column.UniqueName] = editorText;
                            }
                            catch (Exception ex)
                            {
                               RadGrid1.Controls.Add(new LiteralControl("Unable to insert into Employees. Reason: " + ex.Message));
                            }
                        }
                    }
                //This should not be applied when updating directly the database
                newRow["EmployeeID"] = (int)employeesTable.Rows[employeesTable.Rows.Count - 1]["EmployeeID"] + 1;

                employeesTable.Rows.Add(newRow);

                Session["employeesTable"] = employeesTable;

                Session["insertFlag"] = null;
        }
        Session["initEdit"] = null;

        RadGrid1.DataSource = (DataTable)Session["employeesTable"];
    }
    protected void RadGrid1_ItemCommand(object source, GridCommandEventArgs e)
    {
        if (e.CommandName == RadGrid.UpdateCommandName)
        {
            RadGrid1.DataSource = null;
        }
        else if (e.CommandName == RadGrid.EditCommandName)
        {
            Session["initEdit"] = true;
            Session["updateFlag"] = true;
        }
        else if (e.CommandName == RadGrid.InitInsertCommandName)
        {
            Session["insertFlag"] = true;
        }
        else if(e.CommandName == RadGrid.DeleteCommandName)
        {
            string ID = e.Item.OwnerTableView.DataKeyValues[e.Item.ItemIndex]["EmployeeID"].ToString();
            DataTable employeesTable = (DataTable)Session["employeesTable"];
            if (employeesTable.Rows.Find(ID) != null)
            {
                employeesTable.Rows.Find(ID).Delete();
                employeesTable.AcceptChanges();
                Session["employeesTable"] = employeesTable;
            }
        }
    }

}
